/**
 *    author:  tourist
 *    created: 13.10.2023 01:26:42       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> p(n);
  for (int i = 1; i < n - 1; i++) {
    cin >> p[i];
  }
  const int inf = (int) 1e9;
  vector<int> d(n, inf);
  d[0] = 0;
  deque<int> que;
  que.push_back(0);
  while (!que.empty()) {
    int i = que.front();
    que.pop_front();
    for (int x = 1; x <= 6; x++) {
      if (i + x < n) {
        int to = i + x - p[i + x];
        int nd = d[i] + (x < 6 || to == n - 1);
        if (nd < d[to]) {
          d[to] = nd;
          if (nd == d[i]) {
            que.push_front(to);
          } else {
            que.push_back(to);
          }
        }
      }
    }
  }
  cout << (d[n - 1] == inf ? -1 : d[n - 1]) << '\n';
  return 0;
}
