#include "testlib.h"
 
using namespace std;
 
int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	int n, m;
	n = inf.readInt(2, 1'000, "n");
	inf.readSpace();
	m = inf.readInt(2, 1'000, "m");
	inf.readSpace();
	inf.readInt(0, 1'000'000, "k");
	inf.readEoln();
    vector<string> g = inf.readLines(n, "[.#]{1,1000}", "g");
    for (int i = 0; i < n; ++i) {
        ensuref((int)g[i].size() == m, "length of g[%d] is not m", i);
    }
    pair<int, int> d, a;
    d.first = inf.readInt(1, n, "d_x");
    inf.readSpace();
    d.second = inf.readInt(1, m, "d_y");
    inf.readEoln();
    a.first = inf.readInt(1, n, "a_x");
    inf.readSpace();
    a.second = inf.readInt(1, m, "a_y");
    inf.readEoln();
    ensuref(d.first != a.first || d.second != a.second, "(d_x, d_y) and (a_x, a_y) cannot be equal");
    ensuref(g[d.first - 1][d.second - 1] == '.', "(d_x, d_y) is not a free cell");
    ensuref(g[a.first - 1][a.second - 1] == '.', "(a_x, a_y) is not a free cell");
	inf.readEof();
}
