/**
 *    author:  tourist
 *    created: 13.10.2023 01:18:02       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

const int di[8] = {-1, 0, 1, 0, -2, 0, 2, 0};
const int dj[8] = {0, -1, 0, 1, 0, -2, 0, 2};

const int N = 1010;

int d[N][N];
bool in_que[N][N];
string s[N];
pair<int, int> que[N * N * 30];

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int h, w, k;
  cin >> h >> w >> k;
  for (int i = 0; i < h; i++) {
    cin >> s[i];
  }
  int si, sj, fi, fj;
  cin >> si >> sj >> fi >> fj;
  --si; --sj; --fi; --fj;
  for (int i = 0; i < h; i++) {
    for (int j = 0; j < w; j++) {
      in_que[i][j] = false;
      d[i][j] = k + 1;
    }
  }
  int sz = 0;
  que[sz++] = make_pair(si, sj);
  d[si][sj] = 0;
  in_que[si][sj] = true;
  for (int b = 0; b < sz; b++) {
    auto p = que[b];
    in_que[p.first][p.second] = false;
    for (int dir = 0; dir < 8; dir++) {
      int ni = p.first + di[dir];
      int nj = p.second + dj[dir];
      if (ni >= 0 && nj >= 0 && ni < h && nj < w) {
        if (s[ni][nj] == '.') {
          int nd = d[p.first][p.second] + (dir >> 2);
          if (nd < d[ni][nj]) {
            d[ni][nj] = nd;
            if (!in_que[ni][nj]) {
              que[sz++] = make_pair(ni, nj);
              in_que[ni][nj] = true;
            }
          }
        }
      }
    }
  }
  cout << (d[fi][fj] <= k ? "YES" : "NO") << '\n';
  return 0;
}
