/**
 *    author:  tourist
 *    created: 13.10.2023 01:42:28       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> pa(n);
  for (int i = 1; i < n; i++) {
    cin >> pa[i];
  }
  vector<int> pb(n);
  for (int i = 1; i < n; i++) {
    cin >> pb[i];
  }
  auto Solve = [&](vector<int> p) {
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
      g[p[i]].push_back(i);
    }
    vector<array<int, 3>> ops;
    while (true) {
      int leaf = 0;
      vector<int> order(1, 0);
      while (!g[leaf].empty()) {
        leaf = g[leaf][0];
        order.push_back(leaf);
      }
      if ((int) order.size() == n) {
        return make_pair(order, ops);
      }
      for (int i = 0; i < n; i++) {
        assert(g[i].size() <= 2);
        if (g[i].size() == 2) {
          ops.push_back({g[i][1], i, leaf});
          g[leaf].push_back(g[i][1]);
          g[i].pop_back();
          break;
        }
      }
    }
  };
  auto xa = Solve(pa);
  auto xb = Solve(pb);
  vector<int> renum(n);
  for (int i = 0; i < n; i++) {
    renum[xb.first[i]] = xa.first[i];
  }
  vector<pair<int, int>> res;
  for (auto& p : xa.second) {
    res.emplace_back(p[0], p[2]);
  }
  reverse(xb.second.begin(), xb.second.end());
  for (auto& p : xb.second) {
    res.emplace_back(renum[p[0]], renum[p[1]]);
  }
  cout << res.size() << '\n';
  for (auto& p : res) {
    cout << p.first << " " << p.second << '\n';
  }
  return 0;
}
