class Point:
    def __init__(self, x = 0, y = 0):
        self.x = x
        self.y = y

    def __sub__(self, other):
        return Point(self.x - other.x, self.y - other.y)
    
    def square_dist(self) -> int:
        return self.x ** 2 + self.y ** 2
    
    def dist(self) -> float:
        return self.square_dist() ** 0.5
    
n = int(input())
mx, square_mx, ans = 0., 0, 0.
prev, f = Point(), Point()
for i in range(n):
    x, y = map(int, input().split())
    p = Point(x, y)
    if i == 0:
        f = p
    else:
        d = p - prev
        ans += d.dist()
        if square_mx < d.square_dist():
            square_mx = d.square_dist()
            mx = d.dist()
    prev = p
d = f - prev
ans += d.dist()
if square_mx < d.square_dist():
    square_mx = d.square_dist()
    mx = d.dist()
print(ans - mx)